Blame IbaTools/disable_ports/opaextractbadlinks.sh

Packit 857059
#!/bin/bash
Packit 857059
# BEGIN_ICS_COPYRIGHT8 ****************************************
Packit 857059
# 
Packit 857059
# Copyright (c) 2015, Intel Corporation
Packit 857059
# 
Packit 857059
# Redistribution and use in source and binary forms, with or without
Packit 857059
# modification, are permitted provided that the following conditions are met:
Packit 857059
# 
Packit 857059
#     * Redistributions of source code must retain the above copyright notice,
Packit 857059
#       this list of conditions and the following disclaimer.
Packit 857059
#     * Redistributions in binary form must reproduce the above copyright
Packit 857059
#       notice, this list of conditions and the following disclaimer in the
Packit 857059
#       documentation and/or other materials provided with the distribution.
Packit 857059
#     * Neither the name of Intel Corporation nor the names of its contributors
Packit 857059
#       may be used to endorse or promote products derived from this software
Packit 857059
#       without specific prior written permission.
Packit 857059
# 
Packit 857059
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
Packit 857059
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
Packit 857059
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
Packit 857059
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
Packit 857059
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
Packit 857059
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
Packit 857059
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
Packit 857059
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
Packit 857059
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
Packit 857059
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
Packit 857059
# 
Packit 857059
# END_ICS_COPYRIGHT8   ****************************************
Packit 857059
Packit 857059
# [ICS VERSION STRING: unknown]
Packit 857059
Packit 857059
# Run opareports and pipe output to opaxmlextract to extract
Packit 857059
#  links with excessive errors
Packit 857059
Packit 857059
tempfile="$(mktemp)"
Packit 857059
trap "rm -f $tempfile; exit 1" SIGHUP SIGTERM SIGINT
Packit 857059
trap "rm -f $tempfile" EXIT
Packit 857059
Packit 857059
cmd=`basename $0`
Packit 857059
Usage_full()
Packit 857059
{
Packit 857059
	echo >&2
Packit 857059
	echo "Usage: ${cmd} [--help]|[opareport options]" >&2
Packit 857059
	echo "   --help - produce full help text" >&2
Packit 857059
	echo "   [opareport options] - options will be passed to opareport." >&2
Packit 857059
	echo >&2
Packit 857059
	echo "${cmd} is a front end to the opareport tool that generates" >&2
Packit 857059
	echo "a report listing all or some of the links that have exceeded the error threshold." >&2
Packit 857059
	echo "The output is in a CSV format suitable for importing into a spreadsheet" >&2
Packit 857059
	echo "or parsed by other scripts." >&2
Packit 857059
	echo >&2
Packit 857059
	echo "for example:" >&2
Packit 857059
	echo "   List all the bad links in the fabric:" >&2
Packit 857059
	echo "      ${cmd}" >&2
Packit 857059
	echo >&2
Packit 857059
	echo "   List all the bad links to a switch named \"coresw1\":" >&2
Packit 857059
	echo "      ${cmd} -F \"node:coresw1\"" >&2
Packit 857059
	echo >&2
Packit 857059
	echo "   List all the bad links to end-nodes:" >&2
Packit 857059
	echo "      ${cmd} -F \"nodetype:FI\"" >&2
Packit 857059
	echo >&2
Packit 857059
	echo "   List all the bad links on the 2nd HFI's fabric of a multi-plane fabric:" >&2
Packit 857059
	echo "      ${cmd} -h 2" >&2
Packit 857059
	echo >&2
Packit 857059
	echo "See the man page for \"opareport\" for the full set of options." >&2
Packit 857059
	echo "By design, the tool ignores \"-o/--output\" report option." >&2
Packit 857059
	echo >&2
Packit 857059
	exit 0
Packit 857059
}
Packit 857059
Packit 857059
Usage()
Packit 857059
{
Packit 857059
	echo >&2
Packit 857059
	echo "Usage: ${cmd} [--help]|[opareport options]" >&2
Packit 857059
	echo "   --help - produce full help text" >&2
Packit 857059
	echo "   [opareport options] - options will be passed to opareport." >&2
Packit 857059
	echo >&2
Packit 857059
}
Packit 857059
Packit 857059
if [ x"$1" = "x--help" ]
Packit 857059
then
Packit 857059
	Usage_full
Packit 857059
fi
Packit 857059
Packit 857059
line1=
Packit 857059
# we do this against a single fabric, options can select a local HFI and Port
Packit 857059
/usr/sbin/opareport -o errors -x -Q "$@" > $tempfile
Packit 857059
if [ -s $tempfile ]
Packit 857059
then
Packit 857059
	cat $tempfile| /usr/sbin/opaxmlextract -H -d \; -e LinkErrors.Link.Port.NodeGUID -e LinkErrors.Link.Port.PortNum -e LinkErrors.Link.Port.NodeType -e LinkErrors.Link.Port.NodeDesc|while read line
Packit 857059
	do
Packit 857059
		if [ x"$line1" = x ]
Packit 857059
		then
Packit 857059
			line1="$line"
Packit 857059
		else
Packit 857059
			echo "$line1;$line"
Packit 857059
			line1=
Packit 857059
		fi
Packit 857059
	done
Packit 857059
	res=0
Packit 857059
else
Packit 857059
	echo "${cmd}: Unable to get error report" >&2
Packit 857059
	Usage
Packit 857059
	res=1
Packit 857059
fi
Packit 857059
rm -f $tempfile
Packit 857059
exit $res